<template>
    <div class="profile_main">
        <div class="content">
            <div class="main_logo">
                <div class="image">
                    <img src="/img/profile-snowflake.svg" class="profile_snowflake">
                </div>
                <div class="main_logo_title">{{$t('message.profile_title')}}</div>
            </div>

            <div class="packages_box">
                <div class="white_hover"></div>
                <div class="scroll_box">
                    <div class="box">
                        <div class="box_title">
                            {{ $t('message.last_packages')}}
                            <span v-if="!isLoading">({{ ordersQty }})</span>
                        </div>
                        <!--                        <div class="packages">-->
                        <!--                            <div class="package under-construction">-->
                        <!--                                <div class="message">{{$t('message.under_construction')}}</div>-->
                        <!--                                <squares-svg></squares-svg>-->
                        <!--                            </div>-->
                        <!--                        </div>-->
                        <div class="packages">
                            <template v-if="orders && orders.length > 0">
                                <div class="package" v-for="(item, index) in orders">
                                    <div class="direction">{{ item.is_incoming == '1' ? $t('message.incoming') :
                                        $t('message.out_package')}}
                                    </div>
                                    <div class="number">{{item.ew_number}}</div>
                                    <div class="description">
                                        <div class="from">
                                            {{item.sender_department_city_ua}}
                                            <div class="dep-number" v-if="item.sender_department_number">
                                                Відділення № {{ item.sender_department_number }}
                                            </div>
                                        </div>
                                        <div class="to">
                                            {{item.receiver_department_city_ua}}
                                            <div class="dep-number" v-if="item.receiver_department_number">
                                                Відділення № {{ item.receiver_department_number }}
                                            </div>
                                        </div>
                                    </div>
                                    <div class="time_line">
                                        <div class="line"
                                             :class="{
                                                'lightblue':(item.status_id == 1),
                                                'blue':([3,4,5,16].includes(parseInt(item.status_id))),
                                                'green':([6,8].includes(parseInt(item.status_id))),
                                                'red':([2,9,14,15].includes(parseInt(item.status_id))),
                                                'half':([4,5,16].includes(parseInt(item.status_id))),
                                                'full':([2,6,8,9,14,15].includes(parseInt(item.status_id))),
                                                'circle':([2,8,9,14,15].includes(parseInt(item.status_id))),
                                                'triangle':([1,3,4,5,6,16].includes(parseInt(item.status_id))),
                                        }"></div>
                                    </div>
                                    <div class="status">
                                        <div class="departure">
                                            <div class="status-title">{{$t('message.sended')}}</div>
                                            <div class="date">{{item.order_date | formatDate}}</div>
                                        </div>
                                        <div class="status_info">
                                            <div class="status-title">{{$t('message.status')}}</div>
                                            <div
                                                class="info"
                                                :class="{
                                                    'info--lightblue':(item.status_id == 1),
                                                    'info--blue':([3,4,5,16].includes(parseInt(item.status_id))),
                                                    'info--green':([6,8].includes(parseInt(item.status_id))),
                                                    'info--red':([2,9,14,15].includes(parseInt(item.status_id))),
                                                }"
                                            >{{statuses[item.status_id].name_ua}}
                                            </div>
                                        </div>
                                    </div>
                                    <router-link :to="{name: 'orderDetails', params: {ew_number: item.ew_number}}"
                                                 class="details_btn">
                                        {{ $t('message.more') }}
                                    </router-link>
                                </div>
                            </template>
                            <template v-else>
                                <div class="no_packages">
                                    <div class="icon">
                                        <logo-squares-svg></logo-squares-svg>
                                    </div>
                                    <div v-if="isLoading" class="animation-inside-container">
                                        <lottie :options="defaultOptions" :height="100" :width="100"/>
                                    </div>
                                    <div v-else class="message">
                                        {{$t('message.no_packages')}}
                                    </div>
                                    <router-link to='/package/create' class="btn">
                                        {{$t('message.create_first_package')}}
                                    </router-link>
                                </div>
                            </template>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="buttons">
            <router-link to="/calculator">
                <calculate-svg></calculate-svg>
                {{$t('message.calculate_cost')}}
            </router-link>
            <a href="" target="_blank">
                <location-svg></location-svg>
                {{$t('message.search_department')}}
            </a>
            <router-link to='/package/create'>
                <package-svg></package-svg>
                {{$t('message.create_package')}}
            </router-link>
        </div>
        <back-to-top bottom="30px" right="18px">
            <button type="button" class="btn btn-info btn-to-top">
                <img src="/img/to-top.svg">
            </button>
        </back-to-top>
    </div>
</template>

<script>
    import Package from './svg/Package';
    import Location from './svg/Location';
    import Calculate from './svg/Calculate';
    import Squares from "./svg/icons/Squares";
    import LogoSquares from "./svg/LogoSquares";
    import BackToTop from './BackToTop';
    import Lottie from 'vue-lottie';
    import * as animationData from './animation/preload.json';

    export default {
        data() {
            return {
                orders: {},
                isLoading: true,
                defaultOptions: {animationData: animationData.default},
                animationSpeed: 1
            }
        },
        name: "ProfileMainComponent",
        components: {
            "package-svg": Package,
            "location-svg": Location,
            "calculate-svg": Calculate,
            "squares-svg": Squares,
            "logo-squares-svg": LogoSquares,
            BackToTop,
            'lottie': Lottie
        },
        filters: {
            formatDate(v) {
                return v.split(' ')[0].split('-').reverse().join('.');
            }
        },
        computed: {
            statuses: function () {
                const reducer = (a, c) => {
                    a[c.code] = c;
                    return a;
                };
                const statuses = this.$store.getters.statuses;

                return statuses && Object.keys(statuses).length
                    ? statuses.reduce(reducer, {})
                    : {};
            },
            ordersQty: function(){
                return this.orders ? Object.keys(this.orders).length : 0;
            }
        },
        methods: {
            async getOrders() {
                try {
                    const filters = {
                        filters: {
                            is_archive: 0
                        },
                        sorting: {
                            date: 'DESC'
                        }
                    };
                    const {data} = await axios.post('/order/list', filters);
                    this.orders = data.result ? data.result.ews : {};
                } catch (e) {}
                this.isLoading = false;
            }
        },
        created() {
            this.$store.dispatch('setStatuses', {});
            this.$store.commit('refreshOrdertStatus', {ttn: false});
            // получение посылок
            this.getOrders();
        }
    }
</script>
